unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, HCMngr, RSA, NMUDP, DBTables, Sample, DECUtil, Komunikace;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    GroupBox2: TGroupBox;
    Memo1: TMemo;
    NMUDP1: TNMUDP;
    HashManager1: THashManager;
    CipherManager1: TCipherManager;
    Session1: TSession;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure NMUDP1DataReceived(Sender: TComponent; NumberBytes: Integer;
      FromIP: String);
    procedure Memo1Change(Sender: TObject);
  private
    { Private declarations }
    PK_Zak,PRK_Zak,PK_Banka_Zak,PK_Obch,PK_PG:string;
    SymetricKey3,SymetricKey2,SymetricKey:string;
    function FindStringFromStream(const str:string):string;
    function ExtractIPFromString(const str:string):string;
    procedure PrijmiZadost(str:string;URL:string);
    procedure MemoHlavicka(memo:TMemo);
    function ZakoupeneZbozi(id:integer;var nazev:string;var pocet,cena:integer):integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  with Session1 do begin
    ConfigMode := cmSession;
    try
      AddStandardAlias('TEMPDIPLOM', ExtractFilePath(ParamStr(0)), 'PARADOX');
    finally
      ConfigMode := cmAll;
    end;
  end;
//  Form1.Table1.Open;
end;

procedure TForm1.FormShow(Sender: TObject);
var time_start,time_end:TDateTime;
begin
     PK_Banka_Zak:='';
     if ParamStr(1)<>'' then
        URL_Obch:=ExtractIPFromString(FindStringFromStream('SET-SET-URL: '));

     MemoHlavicka(Form1.Memo1);
     Form1.Memo1.Lines.Add('Generuji veejn a privtn kl ...');
     time_start:=Time;
     PK_Zak:='++11Ik:qhONEEhsJQf3feTf+8slWx4DnhKP8k+6lkl+'+
                        'f8ZgIzpIIHjAfAyUPswLloKQwK7MFvxSkFb9NgLL7numF6k+8k';
     PRK_Zak:='qhONEEhsJQf3feTf+8slWx4DnhKP8k+6lkl+f8ZgIzpIIHjAfAyUP'+
                         'swLloKQwK7MFvxSkFb9NgLL7numF6k+8k:o369Qr+wntzXlsCPwoG'+
                         '-jU0iSWYa-cbdL0peTsaTbkrr5KcvCU6exE+JO4iaYY0UBwEGEolb9Ero3uwD20ftKk';
     time_end:=Time;
     Form1.Memo1.Lines.Add('   Privtn kl:');
     Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PRK_Zak),length(PRK_Zak),fmtHEX));
     Form1.Memo1.Lines.Add('   Veejn kl:');
     Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PK_Zak),length(PK_Zak),fmtHEX));
     Form1.Memo1.Lines.Add('   Hotovo , doba generovn: '+TimeToStr(time_end-time_start));

     PosliVerejnyKlic(URL_Banka_Zak,Port_Banka_Zak,PK_Zak,99);

     Form1.Label4.Caption:=Jmeno+' '+Prijmeni;
     Form1.Label5.Caption:=RC;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Form2.Close;
end;

function TForm1.FindStringFromStream(const str:string):string;
var Tmp:TStringList;
    i:integer;
begin
     Tmp:=TStringList.Create;
     try
        DataStream.Position:=0;
        Tmp.LoadFromStream(DataStream);
        for i:=0 to Tmp.Count-1 do begin
            if Copy(Tmp.Strings[i],1,length(str))=str then
               FindStringFromStream:=Copy(Tmp.Strings[i],length(str)+1,length(Tmp.Strings[i])-length(str));
        end;
     finally
        Tmp.Free;
     end;
end;

function TForm1.ExtractIPFromString(const str:string):string;
var tmp:string;
begin
     tmp:=copy(str,8,15);
     Result:=Copy(tmp,1,pos('/',tmp)-1);
end;

procedure TForm1.NMUDP1DataReceived(Sender: TComponent;
  NumberBytes: Integer; FromIP: String);
var
  MyStream: TMemoryStream;
  TmpStr: String;
begin
  MyStream := TMemoryStream.Create;
  try
    NMUDP1.ReadStream(MyStream);
    SetLength(TmpStr,NumberBytes);
    MyStream.Read(TmpStr[1],NumberBytes);
    MemoHlavicka(Form1.Memo1);
    Form1.Memo1.Lines.Add('Pijata data od '+FromIP+', Dlka: '+IntToStr(NumberBytes)+' bajt');
    PrijmiZadost(TmpStr,FromIP);
  finally
    MyStream.Free;
  end;
end;

procedure TForm1.PrijmiZadost(str:string;URL:string);
var id:integer;
    i,pocet,cena,cena_celkem:integer;
    nazev,zprava:string;
begin
     id:=strtoint('$'+Copy(str,1,2));
     Form1.Memo1.Lines.Add('   ID zprvy: '+inttostr(id));
     case id of
         98: begin
                  PrijmiVerejnyKlic(str,PK_Banka_Zak);
                  Form1.Memo1.Lines.Add('   Veejn kl banky zkaznka:');
                  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PK_Banka_Zak),length(PK_Banka_Zak),fmtHEX));
                  SymetricKey3:=GenerujSymetrickyKlic(24);
                  PosliSymetrickyKlic(SymetricKey3,PK_Banka_Zak,URL_Banka_Zak,Port_Banka_Zak,89);
                  sleep(2000);
                  PosliZpravu(URL_Banka_Zak,Port_Banka_Zak,HASH,1,PK_Banka_Zak,SymetricKey3);
             end;
          2: begin
                  PrijmiZpravu(str,SymetricKey3,PK_Zak,PRK_Zak,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                  end else begin
                     Form1.Label6.Caption:=zprava+' K';
                     Form1.Memo1.Lines.Add('   Zkaznk m na tu '+zprava+' K');
                     if ParamStr(1)<>'' then begin
                        Form1.MemoHlavicka(Form1.Memo1);
                        Form1.Memo1.Lines.Add('   Objednan zbo:');
                        Form1.Memo1.Lines.Add(Format('   %-30s %5s %10s',['Nzev','Poet','Cena']));
                        cena_celkem:=0;
                        for i:=1 to ZakoupeneZbozi(0,nazev,pocet,cena) do begin
                            ZakoupeneZbozi(i,nazev,pocet,cena);
                            cena_celkem:=cena_celkem+cena;
                            Form1.Memo1.Lines.Add(Format('   %-30s %4d %10d K',[nazev,pocet,cena]));
                        end;
                        if strtoint(zprava)<cena_celkem then begin
                           Form1.Memo1.Lines.Add('');
                           zprava:='*** Zkaznk m nedostatenou hotovost na tu.';
                           Form1.Memo1.Lines.Add(zprava);
                           Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                           PosliZpravu(URL_Banka_Zak,Port_Banka_Zak,zprava,21,PK_Banka_Zak,SymetricKey3);
                        end else
                           PosliZpravu(URL_Banka_Zak,Port_Banka_Zak,'IP',75,PK_Banka_Zak,SymetricKey3);
                     end else begin
                        PosliZpravu(URL_Banka_Zak,Port_Banka_Zak,HASH,13,PK_Banka_Zak,SymetricKey3);
                     end;
                  end;
             end;
         13: begin
                  PrijmiZpravu(str,SymetricKey3,PK_Zak,PRK_Zak,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                  end else begin
                     Form1.Memo1.Lines.Add('   Zkaznk provedl tyto platby:');
                     Form1.Memo1.Lines.Add('');
                     Form1.Memo1.Lines.Add('   Datum       as          stka        Na konto');
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                  end;
             end;
         76: begin
                  PrijmiZpravu(str,SymetricKey3,PK_Zak,PRK_Zak,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                  end else begin
                     Form1.Memo1.Lines.Add('   Odpov na dost o URL platebn brny.');
                     Form1.Memo1.Lines.Add('   URL: '+zprava);
                     URL_PG:=zprava;
                     PosliVerejnyKlic(URL_PG,Port_PG,PK_Zak,99);
                  end;
             end;
         95: begin
                  PrijmiVerejnyKlic(str,PK_PG);
                  Form1.Memo1.Lines.Add('   Veejn kl platebn brny:');
                  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PK_PG),length(PK_PG),fmtHEX));
                  PosliVerejnyKlic(URL_Obch,Port_Obch,PK_Zak,99);
             end;
         96: begin
                  PrijmiVerejnyKlic(str,PK_Obch);
                  Form1.Memo1.Lines.Add('   Veejn kl obchodnka:');
                  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PK_Obch),length(PK_Obch),fmtHEX));
                  SymetricKey2:=GenerujSymetrickyKlic(24);
                  PosliSymetrickyKlic(SymetricKey2,PK_PG,URL_PG,Port_PG,89);
                  SymetricKey:=GenerujSymetrickyKlic(24);
                  PosliSymetrickyKlic(SymetricKey,PK_Obch,URL_Obch,Port_Obch,89);
                  ZakoupeneZbozi(0,nazev,pocet,cena);
                  PosliDvojitouZpravu(VytvorZpravu(HASH,SymetricKey2,PK_PG),VytvorZpravu(nazev,SymetricKey,PK_Obch),URL_Obch,79,Port_Obch);
             end;
         10: begin
                  PrijmiZpravu(str,SymetricKey2,PK_Zak,PRK_Zak,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                  end else begin
                     Form1.Memo1.Lines.Add('   Objednan zbo bylo zaplaceno z tu zkaznka: '+zprava+' K');
                  end;
             end;
         20: begin
                  PrijmiZpravu(str,SymetricKey2,PK_Zak,PRK_Zak,zprava);
                  Form1.Memo1.Lines.Add(zprava);
                  Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
             end;
         22: begin
                  PrijmiZpravu(str,SymetricKey3,PK_Zak,PRK_Zak,zprava);
                  Form1.Memo1.Lines.Add(zprava);
                  Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
             end;
         23: begin
                  PrijmiZpravu(str,SymetricKey,PK_Zak,PRK_Zak,zprava);
                  Form1.Memo1.Lines.Add(zprava);
                  Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
             end;
         25: begin
                  PrijmiZpravu(str,SymetricKey2,PK_Zak,PRK_Zak,zprava);
                  Form1.Memo1.Lines.Add(zprava);
                  Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
             end;
     end;
end;

procedure TForm1.MemoHlavicka(memo:TMemo);
begin
     memo.Lines.Add('');
     memo.Lines.Add(FormatDateTime('dd.mm.yyyy ',Date)+FormatDateTime('hh:nn:ss',Time));
end;

function TForm1.ZakoupeneZbozi(id:integer;var nazev:string;var pocet,cena:integer):integer;
var i:integer;
    Tmp:TStringList;
    tmp_str:string;
begin
     Tmp:=TStringList.Create;
     try
        DataStream.Position:=0;
        Tmp.LoadFromStream(DataStream);
        Result:=Tmp.Count-9;
        if id>0 then begin
           nazev:=Copy(Tmp.Strings[id+8],1,pos(';',Tmp.Strings[id+8])-1);
           tmp_str:=Copy(Tmp.Strings[id+8],pos(';',Tmp.Strings[id+8])+1,length(Tmp.Strings[id+8]));
           pocet:=strtoint(Copy(tmp_str,1,pos(';',tmp_str)-1));
           cena:=strtoint(Copy(tmp_str,pos(';',tmp_str)+1,length(tmp_str)));
        end else begin
           nazev:='';
           for i:=1 to Tmp.Count-9 do
               nazev:=nazev+Tmp.Strings[i+8]+#13#10;
           pocet:=0;
           cena:=0;
        end;
     finally
        Tmp.Free;
     end;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
     if copy(Form1.Memo1.Lines[Form1.Memo1.Lines.Count],1,3)='---' then begin
        SymetricKey:='';
        SymetricKey2:='';
        SymetricKey3:='';
        PK_PG:='';
        PK_Obch:='';
        PK_Banka_Zak:='';
     end;
end;

end.
